***

title: Capture a signature
published: true
---------------------

For clean Markdown of any page, append .md to the page URL. For a complete documentation index, see https://docs.payroc.com/full-stack-guides/take-payments/payroc-cloud/extend-your-solution/llms.txt. For full documentation content, see https://docs.payroc.com/full-stack-guides/take-payments/payroc-cloud/extend-your-solution/llms-full.txt.

<Note>
  **Note:** To find out how to authorize your requests and handle errors, go to [Before You Begin](/guides/take-payments/payroc-cloud/extend-your-solution/extend.mdx#Before-you-begin).
</Note>

After you configure a device for Payroc Cloud, program your POS to use the Submit Signature Instruction method to send a signature instruction to the payment device.

To capture a cardholder’s signature, complete the following:

1. Submit a signature instruction to the device.
2. View the status of the signature instruction.
3. View the signature.

You can also cancel a signature instruction if it hasn’t yet completed.

## Step 1. Submit a signature instruction

To submit a signature instruction to a device, send a POST request to the Devices endpoint.

| Endpoint   | Prefix   | URL                                                                                                                                                          |
| ---------- | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| Test       | api.uat. | [https://api.uat.payroc.com/v1/devices/\{serialNumber}/signature-instructions](https://api.uat.payroc.com/v1/devices/\{serialNumber}/signature-instructions) |
| Production | api.     | [https://api.payroc.com/v1/devices/\{serialNumber}/signature-instructions](https://api.payroc.com/v1/devices/\{serialNumber}/signature-instructions)         |

### Request parameters

To create the body of your request, use the following parameters:

<EndpointSchemaSnippet endpoint="POST /signature-instructions/{signatureInstructionId}" selector="request.body" />

#### Example request

<EndpointRequestSnippet endpoint="POST /signature-instructions/{signatureInstructionId}" />

### Response fields

If your request is successful, we send the signature instruction to the device.

<Note>
  **Note:** The response returns a value of `inProgress` for the status field and an identifier for the instruction that you can use to check the status of the instruction. To get a link to view the details of the signature capture, go to Step 2.
</Note>

<EndpointSchemaSnippet endpoint="POST /signature-instructions/{signatureInstructionId}" selector="response.body" />

#### Example response

<EndpointResponseSnippet endpoint="POST /signature-instructions/{signatureInstructionId}" example="paymentInstruction" />

## Step 2. View the status of a signature instruction

To check for updates to the status of the signature instruction, send a GET request to the Signature Instructions endpoint.

| Endpoint   | Prefix   | URL                                                                                                                                                              |
| ---------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| Test       | api.uat. | [https://api.uat.payroc.com/v1/signature-instructions/\{signatureInstructionId}](https://api.uat.payroc.com/v1/signature-instructions/\{signatureInstructionId}) |
| Production | api.     | [https://api.payroc.com/v1/signature-instructions/\{signatureInstructionId}](https://api.payroc.com/v1/signature-instructions/\{signatureInstructionId})         |

Before our gateway sends a response, it waits for up to a minute for the status of the instruction to change. We recommend that you keep the session open until the status of the instruction changes or the request times out.

If the status of the instruction doesn’t change, send another GET request. Our gateway waits up to a minute for the status of the instruction to change. Continue to send GET requests until the status changes.

<Note>
  **Note:** Wait until you receive a response from our gateway before you send another request.
</Note>

### Request parameters

To create your request, use the following parameters:

<EndpointSchemaSnippet endpoint="GET /signature-instructions/{signatureInstructionId}" selector="request.path" />

#### Example request

<EndpointRequestSnippet endpoint="GET /signature-instructions/{signatureInstructionId}" />

### Response fields

If your request is successful, we return the details of the signature instruction, including HATEOAS links to check the signature. Use the HATEOAS links to get the signatureId, which you need in Step 3.

If the status of the signature instruction is `inProgress`, our gateway waits up to a minute for the status to change before it returns a response.

<EndpointSchemaSnippet endpoint="GET /signature-instructions/{signatureInstructionId}" selector="response.body" />

#### Example response

<EndpointResponseSnippet endpoint="GET /signature-instructions/{signatureInstructionId}" example="Retrieved" />

## Step 3. View the signature capture

To view the signature that the payment device captured, send a GET request to the Signatures endpoint.

| Endpoint   | Prefix   | URL                                                                                                                |
| ---------- | -------- | ------------------------------------------------------------------------------------------------------------------ |
| Test       | api.uat. | [https://api.uat.payroc.com/v1/signatures/\{signatureId}](https://api.uat.payroc.com/v1/signatures/\{signatureId}) |
| Production | api.     | [https://api.payroc.com/v1/signatures/\{signatureId}](https://api.payroc.com/v1/signatures/\{signatureId})         |

### Request parameters

To create your request, use the following parameters:

<EndpointSchemaSnippet endpoint="GET /signatures/{signatureId}" selector="request.path" />

#### Example request

<EndpointRequestSnippet endpoint="GET /signatures/{signatureId}" />

### Response fields

If your request is successful, we return the details of the signature.

<EndpointSchemaSnippet endpoint="GET /signatures/{signatureId}" selector="response.body" />

#### Example response

<EndpointResponseSnippet endpoint="GET /signatures/{signatureId}" example="Retrieved" />

## (Optional) Cancel a signature instruction

To cancel a signature instruction, send a DELETE request to the Signature Instructions endpoint.

| Endpoint   | Prefix   | URL                                                                                                                                                              |
| ---------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| Test       | api.uat. | [https://api.uat.payroc.com/v1/signature-instructions/\{signatureInstructionId}](https://api.uat.payroc.com/v1/signature-instructions/\{signatureInstructionId}) |
| Production | api.     | [https://api.payroc.com/v1/signature-instructions/\{signatureInstructionId}](https://api.payroc.com/v1/signature-instructions/\{signatureInstructionId})         |

<Note>
  **Note:** You can cancel a signature instruction only if its status is `inProgress`.
</Note>

### Request parameters

To create your request, use the following parameters:

<EndpointSchemaSnippet endpoint="DELETE /signature-instructions/{signatureId}" selector="request.path" />

#### Example request

<EndpointSchemaSnippet endpoint="DELETE /signature-instructions/{signatureId}" />

### Response fields

If your request is successful, we cancel the signature instruction.